#include <iostream.h>
#include <math.h>
#include "matrix.h"

#ifndef M_PI
#define M_PI acos (-1.0)
#endif

MATRIX DctMatrix ;
MATRIX IDctMatrix ;

static bool Initialized ;

void InitializeDctMatrix ()
{
  if (Initialized)
    return ;

  Initialized = true ;

  unsigned int ii, jj ;

  for (jj = 0 ; jj < JpegSampleWidth ; ++ jj)
    DctMatrix [0][jj] = 1.0 / sqrt (8.0) ;

  for (ii = 1 ; ii < JpegSampleWidth ; ++ ii)
  {
    for (jj = 0 ; jj < JpegSampleWidth ; ++ jj)
    {
      DctMatrix [ii][jj] = 0.5 * cos (((2 * jj + 1) * ii) * M_PI /16.0) ;
    }
  }

  for (ii = 0 ; ii < JpegSampleWidth ; ++ ii)
  {
    for (jj = 0 ; jj < JpegSampleWidth ; ++ jj)
    {
      IDctMatrix [ii][jj] = DctMatrix [jj][ii] ;
    }
  }
  return ;
}


void Multiply (MATRIX aa, MATRIX bb, MATRIX cc)
{
  unsigned int ii, jj, kk ;
  for (ii = 0 ; ii < JpegSampleWidth ; ++ ii)
  {
    for (jj = 0 ; jj < JpegSampleWidth ; ++ jj)
    {
      cc [ii][jj] = 0.0 ;
      for (kk = 0 ; kk < JpegSampleWidth ; ++ kk)
      {
        cc [ii][jj] += aa [ii][kk] * bb [kk][jj] ;  
      }
    }
  }
  return ;
}

